/**
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
**/
 
const St = imports.gi.St;
const Mainloop = imports.mainloop;
const Main = imports.ui.main;

const Clutter = imports.gi.Clutter;
const Lang = imports.lang;

const Search = imports.ui.search;
const searchProviders = Main.overview._viewSelector._searchTab._searchSystem._providers;
const searchProviderscount= searchProviders.length

const langSearchProvider = new Lang.Class({
    Name: 'langSearchProvider',
    Extends: Search.SearchProvider,

    _init: function(title, interpretations) {
        this.ssystem_id=interpretations[1];
        Search.SearchProvider.prototype._init.call(this, searchProviders[this.ssystem_id].title+' ('+title+')');
        this._buildTemplates(interpretations);
        this.lang=interpretations[0];
	
	this.addon='irenswich';
    },

   _buildTemplates: function(interpretations) {
        this.templates = [];
    },
                  
    _switchlayout: function(terms){
        var replaceArr=Array();
        if (this.lang=='ir'){
            replaceArr={'q':'\u0636',
                        'w':'\u0635',
                        'e':'\u062B',
                        'r':'\u0642',
                        't':'\u0641',
                        'y':'\u063A',
                        'u':'\u0639',
                        'i':'\u0647',
                        'o':'\u062E',
                        'p':'\u062D',
                        '[':'\u062C',
                        ']':'\u0686',
                        'a':'\u0634',
                        's':'\u0633',
                        'd':'\u06CC',
                        'f':'\u0628',
                        'g':'\u0644',
                        'h':'\u0627',
                        'j':'\u062A',
                        'k':'\u0646',
                        'l':'\u0645',
                        ';':'\u06A9',
                        "'":'\u06AF',
                        'z':'\u0638',
                        'x':'\u0637',
                        'c':'\u0632',
                        'v':'\u0631',
                        'b':'\u0630',
                        'n':'\u062F',
                        'm':'\u067E',
                        ',':'\u0648',
                        'C':'\u0698',
                        'H':'\u0622',
                        
                        '0':'\u06F0',
                        '1':'\u06F1',
                        '2':'\u06F2',
                        '3':'\u06F3',
                        '4':'\u06F4',
                        '5':'\u06F5',
                        '6':'\u06F6',
                        '7':'\u06F7',
                        '8':'\u06F8',
                        '9':'\u06F9'
                       };
        }else{
            replaceArr={'\u0636':'q',
                        '\u0635':'w',
                        '\u062B':'e',
                        '\u0642':'r',
                        '\u0641':'t',
                        '\u063A':'y',
                        '\u0639':'u',
                        '\u0647':'i',
                        '\u062E':'o',
                        '\u062D':'p',
                        '\u062C':'[',
                        '\u0686':']',
                        '\u0634':'a',
                        '\u0633':'s',
                        '\u06CC':'d',
                        '\u0628':'f',
                        '\u0644':'g',
                        '\u0627':'h',
                        '\u062A':'j',
                        '\u0646':'k',
                        '\u0645':'l',
                        '\u06A9':';',
                        '\u06AF':"'",
                        '\u0638':'z',
                        '\u0637':'x',
                        '\u0632':'c',
                        '\u0631':'v',
                        '\u0630':'b',
                        '\u062F':'n',
                        '\u067E':'m',
                        '\u0648':',',
                        '\u0698':'C',
                        '\u0622':'H',
                        
                        '\u06F0':'0',
                        '\u06F1':'1',
                        '\u06F2':'2',
                        '\u06F3':'3',
                        '\u06F4':'4',
                        '\u06F5':'5',
                        '\u06F6':'6',
                        '\u06F7':'7',
                        '\u06F8':'8',
                        '\u06F9':'9'
                       };
        }
        var newstring=terms.toLowerCase()
    	aryText = new Array(newstring.length)
        for (i = 0; i < newstring.length; i++) {
            aryText[i] = newstring.charAt(i)
        }

        output='';
        for (var i in aryText){
            if (replaceArr.hasOwnProperty(aryText[i])){
                output=output.concat(replaceArr[aryText[i]])
            }else{
                output=output.concat(aryText[i])
            }
        }
        return output;
    },

    getInitialResultSet: function(terms) {
         var newterms=Array();
        tmp=false
        for(i=0;i<terms.length;i++){
            newterms[i]=terms[i]
            newt=this._switchlayout(newterms[i]);
            if (newt!=newterms[i]){
                newterms[i]=newt;
                tmp=true
            }
        }
        if (tmp){
          
            r=searchProviders[this.ssystem_id].getInitialResultSet(newterms)
            return r;

        }else{
            return [];
        }
	
    },

    getSubsearchResultSet: function(previousResults, terms) {
        var newterms=Array();
        tmp=false
        for(i=0;i<terms.length;i++){
            newterms[i]=terms[i]
            newt=this._switchlayout(newterms[i]);
            if (newt!=newterms[i]){
                newterms[i]=newt;
                tmp=true
            }
        }
        if (tmp){
            r=searchProviders[this.ssystem_id].getSubsearchResultSet(previousResults, newterms)
            return r;
        }else{
            return [];
        }
    },

    getResultMeta: function(resultId) {
	return searchProviders[this.ssystem_id].getResultMeta(resultId)
    },
    getResultMetas: function(resultIds) {
	return searchProviders[this.ssystem_id].getResultMetas(resultIds)
    },
    activateResult: function(resultId) {
	
        return searchProviders[this.ssystem_id].activateResult(resultId)
    },
    createResultActor: function(resultMeta, terms) {

        return  searchProviders[this.ssystem_id].createResultActor(resultMeta, terms)
    },

    createResultContainerActor: function() {
       return  searchProviders[this.ssystem_id].createResultContainerActor();
    }
  
});

function irenSearchProvider(id) {
    this._init(id);
}

irenSearchProvider.prototype = {
    __proto__: langSearchProvider.prototype,

    _init: function(id) {
        let interpretations = ['ir',id];
        langSearchProvider.prototype._init.call(this, _("EN->IR"), interpretations);
    }
};

function enirSearchProvider(id) {
    this._init(id);
}

enirSearchProvider.prototype = {
    __proto__: langSearchProvider.prototype,

    _init: function(id) {
        let interpretations = ['en',id];
        langSearchProvider.prototype._init.call(this, _("IR->EN"), interpretations);
    }
};

function init() {

}

function enable() {
    for(i=0;i<searchProviderscount;i++){
    	Main.overview.addSearchProvider(new irenSearchProvider(i));
    	Main.overview.addSearchProvider(new enirSearchProvider(i));
    }
}

function disable(){
    i=0;
    while(i<searchProviders.length){
        if (searchProviders[i].addon=='irenswich'){
            Main.overview.removeSearchProvider(searchProviders[i])
        }else i++;
    }
}
